#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

/* Funkcija za obradu greske. */
void error_fatal (const char *message){
  perror (message);
  exit (EXIT_FAILURE);
}

/* Program demonstrira unlink sistemski poziv. Otvara se fajl po imenu tmp
   i unlink-uje. Ako se proces pokrene u pozadini i tokom perioda kada je proces
   uspavan na 10 sekundi pokrene komanda
   df .
   pa ista komanda pokrene i po prekidu procesa, trebalo bi da se uoci da se 
   kolicina slobodnog prostora uvecava tek po zavrsetku procesa, iako komanda ls
   tokom procesa izvestava da odrednica tmp vise ne postoji. Na alas-u se mogu
   dobiti cudni rezultati jer mozda i drugi korisnici zauzimaju/pustaju memoriju. */
int main(){
  char file_name [] = "tmp";

  // Pretpostavka je da fajl sa imenom "tmp" vec postoji
  if (open (file_name, O_RDWR) < 0)
    error_fatal ("open error");

  if (unlink (file_name) < 0)
    error_fatal ("unlink error");

  sleep (10);

  return 0;
}
